#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_GoldenTurtleHitCFG.h"
std::auto_ptr<Fish_GoldenTurtleHitCFG> Fish_GoldenTurtleHitCFG::msSingleton(nullptr);

int Fish_GoldenTurtleHitCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_GoldenTurtleHitCFGData* Fish_GoldenTurtleHitCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_GoldenTurtleHitCFGData>& Fish_GoldenTurtleHitCFG::GetMapData()
{
	return mMapData;
}

void Fish_GoldenTurtleHitCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_GoldenTurtleHitCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_GoldenTurtleHitCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.mMinimumvalue = element->IntAttribute("Minimumvalue");
		data.mMaximumvalue = element->IntAttribute("Maximumvalue");
		data.mCoefficient = element->IntAttribute("Coefficient");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_GoldenTurtleHitCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GoldenTurtleHitCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_GoldenTurtleHitCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_GoldenTurtleHitCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_GoldenTurtleHitCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readInt(L, "Minimumvalue", data.mMinimumvalue);
		LuaCfgHelper::readInt(L, "Maximumvalue", data.mMaximumvalue);
		LuaCfgHelper::readInt(L, "Coefficient", data.mCoefficient);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_GoldenTurtleHitCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_GoldenTurtleHitCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_GoldenTurtleHitCFG* Fish_GoldenTurtleHitCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_GoldenTurtleHitCFG());
	}
	return msSingleton.get();
}

void Fish_GoldenTurtleHitCFG::Release()
{
	msSingleton.reset(nullptr);
}
